##############################################################
# Rays Brake distance
# 
#############################################################

import ac
import acsys
import sys
import math

appWindow=0
count=0
distance=0
vmax=0
distance100=0	# Brake distance from 100km/h to 0
brakeAktive=0	# Flag if brake was triggerd

# This function gets called by AC when the Plugin is initialised
# The function has to return a string with the plugin name
def acMain(ac_version):
   global speedLabel, brakeLabel, xLabel, yLabel, zLabel, slipFrontLabel, distance100Label, slipRearLabel, OldXValue, OldYValue, OldZValue
   appWindow = ac.newApp("Brake distance")
   ac.setSize(appWindow, 300, 300)
   
   # Speed
   speedLabel = ac.addLabel(appWindow, "Speed:")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(speedLabel, 3, 30)

   # Brake
   brakeLabel = ac.addLabel(appWindow, "Brake Level:")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(brakeLabel, 3, 60)

   # X-Pos
   xLabel = ac.addLabel(appWindow, "Total Distance:")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(xLabel, 3, 90)

   # Y-Pos
   # yLabel = ac.addLabel(appWindow, "Y:")
   # Position (Label, x-Pos, y-Pos)
   # ac.setPosition(yLabel, 3, 120)

   # Z-Pos
   # zLabel = ac.addLabel(appWindow, "Z:")
   # Position (Label, x-Pos, y-Pos)
   # ac.setPosition(zLabel, 3, 150)

   # Brake distance from 100 km/h to 0
   distance100Label = ac.addLabel(appWindow, "Brake distance 100km/h to 0:")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(distance100Label, 3, 180)

   # Slip - Angle
   # slipFrontLabel = ac.addLabel(appWindow, "Slip Front:")
   # Position (Label, x-Pos, y-Pos)
   # ac.setPosition(slipFrontLabel, 3, 180)

   # slipRearLabel = ac.addLabel(appWindow, "Slip Rear:")
   # Position (Label, x-Pos, y-Pos)
   # ac.setPosition(slipRearLabel, 3, 210)

   ac.addRenderCallback(appWindow, onFormRender)
   return "Brake distance"

def onFormRender(deltaT):
   global speedLabel, brakeLabel, xLabel, yLabel, zLabel, slipFrontLabel, distance100Label, slipRearLabel, OldXValue, OldYValue, OldZValue, count, distance, vmax, distance100, brakeAktive

   speedValueKMH = ac.getCarState(0, acsys.CS.SpeedKMH)
   if vmax < speedValueKMH:
      vmax = speedValueKMH

   ac.setText(speedLabel, "Speed: {:.0f} km/h       Vmax: {:.0f} km/h".format(speedValueKMH,vmax))

   brakeValue = ac.getCarState(0, acsys.CS.Brake)
   ac.setText(brakeLabel, "Brake Level: {:.2f}".format(brakeValue))
   if brakeValue != 0:
      brakeAktive=1

   # get the world position and direction
   if count==0:
      #distance=0
      OldXValue, OldYValue, OldZValue = ac.getCarState(0, acsys.CS.WorldPosition)
      count=1
   else:
      x, y, z = ac.getCarState(0, acsys.CS.WorldPosition)
      dx=x-OldXValue
      dy=y-OldYValue
      dz=z-OldZValue
      OldXValue=x
      OldYValue=y      
      OldZValue=z
      deltaQ=dx*dx+dy*dy+dz*dz
      delta=math.sqrt(deltaQ)
      distance=distance+delta
      count=count+1

   ac.setText(xLabel, "Total Distance: {:.2f} m".format(distance))
   
   if brakeAktive==1 and speedValueKMH < 100 and vmax > 100:
      distance100=distance100+delta

   ac.setText(distance100Label, "Brake distance 100km/h to 0: {:.2f} m".format(distance100))

   if brakeValue == 0 and speedValueKMH > 20 and brakeAktive:
      brakeAktive=0
      count=0
      #distance=0
      distance100=0
      vmax=0

   #ac.setText(yLabel, "Count: {:.0f}".format(count))
   #ac.setText(zLabel, "Z: {:.8f}".format(z))

   #fl, fr, rl, rr = ac.getCarState(0, acsys.CS.SlipRatio)
   #ac.setText(slipFrontLabel, "FL: {:.3f}  FR: {:.3f}".format(fl,fr))
   #ac.setText(slipRearLabel, "RL: {:.3f}  RR: {:.3f}".format(rl,rr))

